#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>

#include "common_ntpshm.h"

int main(int argc, char **argv)
{
  int unit;

  struct ntpshm *shm;
  struct ntpshm last, copy;

  if (argc != 2) {
    fprintf(stderr, "usage: mon_ntpshm <ntpshm-seg>\n");
    return 1;
  }
  
  unit = atoi(argv[1]);

  if ((shm = get_ntpshm(unit)) == NULL)
    err(1, "get_ntpshm");

  memset(&last,0,sizeof(last));
  memset(&copy,0,sizeof(copy));

  for ( ; ; )
    {
      memcpy(&copy,shm,sizeof(copy));
      if (!memcmp(&copy,&last,sizeof(copy)))
	{
	  usleep(90000);
	  continue;
	}
      memcpy(&last,&copy,sizeof(last));

      int64_t diff = (last.clockTimeStampUSec - last.receiveTimeStampUSec) +
	(last.clockTimeStampSec - last.receiveTimeStampSec) * 
	(int64_t) 1000000;
      
      printf ("m:%d c:%6d %10ld.%06d @ %10ld.%06d l:%d p:%3d s:%d v:%d (%lld)\n",
	      last.mode,
	      last.count,
	      (long) last.clockTimeStampSec,
	      last.clockTimeStampUSec,
	      (long) last.receiveTimeStampSec,
	      last.receiveTimeStampUSec,
	      last.leap,
	      last.precision,
	      last.nsamples,
	      last.valid,
	      diff);
      
      usleep(90000);
    }
  
  return 0;
}
